/************************************************************************/
/*																		*/
/*	Dcpu.h	--	Interface Declarations for PIC32 cpu				*/
/*																		*/
/************************************************************************/
/*	Author:		Oliver Jones											*/
/*	Copyright 2011, Digilent Inc.										*/
/************************************************************************/
/*  File Description:													*/
/*																		*/
/*																		*/
/************************************************************************/
/*  Revision History:													*/
/*																		*/
/*	07/21/2011(OliverJ): created										*/
/*																		*/
/************************************************************************/

#if !defined(DCPU_INC)
#define DCPU_INC

/* ------------------------------------------------------------ */
/*					Miscellaneous Declarations					*/
/* ------------------------------------------------------------ */

/* ------------------------------------------------------------ */
/*					General Type Declarations					*/
/* ------------------------------------------------------------ */

/*	CPU STATUS
*/
#define	bnCu3				31
#define bnCu2				30
#define bnCu1				29
#define bnCu0				28
#define bnRp				27
#define bnFr				26
#define bnRe				25
// Bits 24-23 Reserved
#define bnBev				22
// Bit 21 Reserved
#define bnSr				20
#define bnNmi				19
// Bits 18-16 Reserved
#define bnIpl5				15
#define bnIpl4				14
#define bnIpl3				13
#define bnIpl2				12
#define bnIpl1				11
#define bnIpl0				10
// Bits 9-5 Reserved
#define bnUm				4
// Bit 3 Reserved
#define bnErl				2
#define bnExl				1
#define bnIe				0
/*******************************/

/*	CPU CAUSE
*/
#define bnBd				31
#define bnTi				30
#define bnCe1				29
#define bnCe0				28
#define bnDc				27
// Bits 26-24 Reserved
#define bnIv				23
// Bits 22-16 Reserved
#define bnRipl5				15
#define bnRipl4				14
#define bnRipl3				13
#define bnRipl2				12
#define bnRipl1				11
#define bnRipl0				10
#define bnIp1				9
#define bnIp0				8
// Bit 7 Reserved
#define bnExccode4			6
#define bnExccode3			5
#define bnExccode2			4
#define bnExccode1			3
#define bnExccode0			2
// Bits 1-0 Reserved
/*******************************/

/* ------------------------------------------------------------ */
/*					Procedure Declarations						*/
/* ------------------------------------------------------------ */

void DcpuEnableInterrupts();

#endif
